#!/usr/bin/perl -I/home/pinson/szpari/programs/Perl/

print STDERR "
                    :-] G R O M A C S [-:
                        helpful tools

                  :-] mdp_randomseed.pl  [-:

Option     Filename  Type          Description
------------------------------------------------------------
";


use Getopt::Std;

$opt_g="yes";
$opt_a="yes";
$opt_l="yes";

$opt_f="mdin.mdp";
$opt_o="mdout.mdp";

getopts('g:l:a:f:o:hv') || die "ERROR in options, exiting\n";

$nmrfile=$opt_n;
$dihedralfile=$opt_d;
$S2file=$opt_s;

if ($opt_h){$HO="yes"} else{$HO="no"}
if($opt_v){$V=1;$VO="yes"}else{$VO="no"}

printf STDERR ("  -f  %12s   Input         mdp file\n",$opt_f);
printf STDERR ("  -o  %12s   Output        mdp file\n",$opt_o);

print STDERR"
      Option   Type  Value  Description
------------------------------------------------------
";

printf STDERR ("          -h   bool %9s  Print help info and quit\n",$HO);
printf STDERR ("          -v   bool %9s  Be loud and noisy\n",$VO);
printf STDERR ("          -g   bool %9s  update gen-seed\n",$opt_g);
printf STDERR ("          -l   bool %9s  update ld-seed\n",$opt_a);
printf STDERR ("          -a   bool %9s  update andersen_seed\n",$opt_a);





if ($opt_h) {
print STDERR "
Updates the seed variables in the input .mdp file
If line with the given seed keyword is not found, it is added to the end 
of the output .mdp file

";
exit;
}


# Reading and processing mdp file
open (I,"$opt_f") || die "FATAL: mdp file $opt_f not found!\n";
if (-e $opt_o){
   print STDERR "Back off! Backing up $opt_o to \#$opt_o\#\n";
   system "mv $opt_o \#$opt_o\#";
}


open (O,">$opt_o") || die "FATAL: Unable to create output file $opt_o!\n";
$found_gen_seed=0;
$found_ld_seed=0;
$found_andersen_seed=0;

while(<I>){

    if (($_=~/^gen_seed/) && ($opt_g =~ /^y/i)){
       $seed=1+rand(1.0)*1000000;$seed=~s/\..*$//;
       print O "gen_seed                 = $seed\n";
       $found_gen_seed=1;
    }
    elsif (($_=~/^ld-seed/) && ($opt_l =~ /^y/i)){
       $seed=1+rand(1.0)*1000000;$seed=~s/\..*$//;
       print O "ld-seed                  = $seed\n";
       $found_ld_seed=1
   }
    elsif (($_=~/^andersen_seed/) && ($opt_a =~ /^y/i)){
	$seed=1+rand(1.0)*1000000;$seed=~s/\..*$//;
       print O "andersen_seed            = $seed\n";
       $found_andersen_seed=1
   }
    else{
	print O $_;
    }
}
close(I);

if (($opt_g) && (!$found_gen_seed)){
    $seed=1+rand(1.0)*1000000;$seed=~s/\..*$//;
    print O "gen_seed                 = $seed\n";
}
if (($opt_l) && (!$found_ld_seed)){
    $seed=1+rand(1.0)*1000000;$seed=~s/\..*$//;
    print O "ld-seed                  = $seed\n";
}
if (($opt_a) && (!$found_andersen_seed)){
    $seed=1+rand(1.0)*1000000;$seed=~s/\..*$//;
    print O "andersen_seed            = $seed\n";
}


 
close(O);
